<script>
import Vue from 'vue';
import CodeEditor from './code-editor/index.vue';

export default Vue.extend({
  components: {
    CodeEditor,
  },
  props: {
    copyBlocks: {
      type: Array,
      required: true,
    },
    codeBlocks: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      currentLinkIndex: 0,
      animate: false,
      observers: null,
    };
  },
  beforeUnmount() {
    this.observer?.disconnect();
  },
});
</script>
<template>
  <div class="slp-mb-96">
    <div ref="target">
      <SlpRow
        v-for="(block, index) in copyBlocks"
        :key="block.title + index"
        class="showcase-row slp-align-items-center"
        :class="{ 'reversed-order': block.reversed }"
      >
        <transition :name="'fade'">
          <SlpColumn :cols="5" class="slp-mb-32 slp-mr-md-48 slp-mb-md-64">
            <SlpTypography
              tag="h2"
              variant="heading2-bold"
              class="slp-mb-24 slp-mt-48"
              >{{ block.title }}</SlpTypography
            >
            <div
              class="slp-text-body1"
              v-html="$md.render(block.description)"
            ></div>
          </SlpColumn>
        </transition>

        <SlpColumn :cols="6">
          <div v-if="block.logos" class="logos-container">
            <img
              v-for="(logo, idx) in block.logos"
              :key="idx"
              :src="logo"
              alt="logo"
            />
          </div>
          <div v-else-if="block.img" class="image-container">
            <img :src="block.img.src" :alt="block.img.src" />
          </div>
          <CodeEditor
            v-else
            :code-blocks="codeBlocks"
            :language-selected="block.languageSelected || 'python'"
          />
        </SlpColumn>
      </SlpRow>
    </div>
  </div>
</template>

<style lang="scss" scoped>
h2,
p,
:deep p {
  color: $color-text-50;
}

:deep p {
  font-size: 20px;
  font-weight: 400;
  line-height: 24px;
}

:deep a {
  text-decoration: underline;
  color: $color-text-50 !important;
}

.showcase-row {
  justify-content: space-between;
  margin: 120px 0;
  max-width: 100%;

  @media (max-width: $breakpoint-md) {
    margin: $spacing-64 0;
    &:first-of-type {
      margin: 0;
    }
  }
  :deep {
    .slp-col-md-6 {
      width: 100%;
    }
  }
}

.visible {
  visibility: visible !important;

  & > * {
    visibility: visible !important;
  }
}

.reversed-order {
  flex-direction: row-reverse;
}

.logos-container {
  display: flex;
  flex-wrap: wrap;
  justify-content: center;
  @media (min-width: $breakpoint-md) {
    justify-content: unset;
  }

  img {
    max-height: 64px;
    margin: $spacing-24;
  }
}

.image-container {
  display: flex;
  justify-content: center;

  img {
    max-width: 100%;
    max-height: 350px;
  }
}
</style>
